//
// Copyright 2022 Vulcanize, Inc.
//
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __asyncValues = (this && this.__asyncValues) || function (o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
import { createLibp2p } from '@cerc-io/libp2p';
// For nodejs.
import wrtc from 'wrtc';
import assert from 'assert';
import { pipe } from 'it-pipe';
import * as lp from 'it-length-prefixed';
import map from 'it-map';
import { pushable } from 'it-pushable';
import { fromString as uint8ArrayFromString } from 'uint8arrays/from-string';
import { toString as uint8ArrayToString } from 'uint8arrays/to-string';
import { webRTCDirect, P2P_WEBRTC_STAR_ID } from '@cerc-io/webrtc-direct';
import { noise } from '@chainsafe/libp2p-noise';
import { mplex } from '@libp2p/mplex';
import { multiaddr } from '@multiformats/multiaddr';
import { floodsub } from '@libp2p/floodsub';
import { pubsubPeerDiscovery } from '@libp2p/pubsub-peer-discovery';
import { MAX_CONCURRENT_DIALS_PER_PEER, MAX_CONNECTIONS, MIN_CONNECTIONS, PUBSUB_DISCOVERY_INTERVAL, PUBSUB_SIGNATURE_POLICY, RELAY_TAG, RELAY_REDIAL_DELAY, CONN_CHECK_INTERVAL, PING_TIMEOUT } from './constants.js';
export var CHAT_PROTOCOL = '/chat/1.0.0';
export var ERR_PROTOCOL_SELECTION = 'protocol selection failed';
var Peer = /** @class */ (function () {
    function Peer(relayNodeURL, nodejs) {
        this._peerStreamMap = new Map();
        this._messageHandlers = [];
        this._topicHandlers = new Map();
        this._peerHeartbeatIntervalIdsMap = new Map();
        this._relayNodeMultiaddr = multiaddr(relayNodeURL);
        var relayPeerId = this._relayNodeMultiaddr.getPeerId();
        assert(relayPeerId);
        // Instantiation in nodejs.
        if (nodejs) {
            this._wrtcTransport = webRTCDirect({ wrtc: wrtc, relayPeerId: relayPeerId, enableSignalling: true });
        }
        else {
            this._wrtcTransport = webRTCDirect({ relayPeerId: relayPeerId, enableSignalling: true });
        }
    }
    Object.defineProperty(Peer.prototype, "peerId", {
        get: function () {
            var _a;
            return (_a = this._node) === null || _a === void 0 ? void 0 : _a.peerId;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Peer.prototype, "node", {
        get: function () {
            return this._node;
        },
        enumerable: false,
        configurable: true
    });
    Peer.prototype.init = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a, err_1;
            var _this = this;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _b.trys.push([0, 2, , 3]);
                        _a = this;
                        return [4 /*yield*/, createLibp2p({
                                addresses: {
                                    // Use existing protocol id in multiaddr to listen through signalling channel to relay node
                                    // Allows direct webrtc connection to a peer if possible (eg. peers on a same network)
                                    listen: ["".concat(this._relayNodeMultiaddr.toString(), "/").concat(P2P_WEBRTC_STAR_ID)]
                                },
                                transports: [this._wrtcTransport],
                                connectionEncryption: [noise()],
                                streamMuxers: [mplex()],
                                pubsub: floodsub({ globalSignaturePolicy: PUBSUB_SIGNATURE_POLICY }),
                                peerDiscovery: [
                                    // Use pubsub based discovery; relay server acts as a peer discovery source
                                    pubsubPeerDiscovery({
                                        interval: PUBSUB_DISCOVERY_INTERVAL
                                    })
                                ],
                                relay: {
                                    enabled: true,
                                    autoRelay: {
                                        enabled: true,
                                        maxListeners: 2
                                    }
                                },
                                connectionManager: {
                                    maxDialsPerPeer: MAX_CONCURRENT_DIALS_PER_PEER,
                                    autoDial: false,
                                    maxConnections: MAX_CONNECTIONS,
                                    minConnections: MIN_CONNECTIONS,
                                    keepMultipleConnections: true // Set true to get connections with multiple multiaddr
                                },
                                ping: {
                                    timeout: PING_TIMEOUT
                                }
                            })];
                    case 1:
                        _a._node = _b.sent();
                        return [3 /*break*/, 3];
                    case 2:
                        err_1 = _b.sent();
                        console.log('Could not initialize a libp2p node', err_1);
                        return [2 /*return*/];
                    case 3:
                        console.log('libp2p node created', this._node);
                        // Dial to the HOP enabled relay node
                        return [4 /*yield*/, this._dialRelay()];
                    case 4:
                        // Dial to the HOP enabled relay node
                        _b.sent();
                        // Listen for change in stored multiaddrs
                        this._node.peerStore.addEventListener('change:multiaddrs', function (evt) {
                            assert(_this._node);
                            var _a = evt.detail, peerId = _a.peerId, multiaddrs = _a.multiaddrs;
                            // Log updated self multiaddrs
                            if (peerId.equals(_this._node.peerId)) {
                                console.log('Updated self multiaddrs', _this._node.getMultiaddrs().map(function (addr) { return addr.toString(); }));
                            }
                            else {
                                console.log('Updated peer node multiaddrs', multiaddrs.map(function (addr) { return addr.toString(); }));
                            }
                        });
                        // Listen for change in peer protocols
                        this._node.peerStore.addEventListener('change:protocols', function (evt) { return __awaiter(_this, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        assert(this._node);
                                        console.log('event change:protocols', evt);
                                        return [4 /*yield*/, this._handleChangeProtocols(evt.detail)];
                                    case 1:
                                        _a.sent();
                                        return [2 /*return*/];
                                }
                            });
                        }); });
                        // Listen for peers discovery
                        this._node.addEventListener('peer:discovery', function (evt) {
                            // console.log('event peer:discovery', evt);
                            _this._handleDiscovery(evt.detail);
                        });
                        // Listen for peers connection
                        this._node.addEventListener('peer:connect', function (evt) { return __awaiter(_this, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        console.log('event peer:connect', evt);
                                        return [4 /*yield*/, this._handleConnect(evt.detail)];
                                    case 1:
                                        _a.sent();
                                        return [2 /*return*/];
                                }
                            });
                        }); });
                        // Listen for peers disconnecting
                        this._node.addEventListener('peer:disconnect', function (evt) {
                            console.log('event peer:disconnect', evt);
                            _this._handleDisconnect(evt.detail);
                        });
                        // Handle messages for the protocol
                        return [4 /*yield*/, this._node.handle(CHAT_PROTOCOL, function (_a) {
                                var stream = _a.stream, connection = _a.connection;
                                return __awaiter(_this, void 0, void 0, function () {
                                    return __generator(this, function (_b) {
                                        this._handleStream(connection.remotePeer, stream);
                                        return [2 /*return*/];
                                    });
                                });
                            })];
                    case 5:
                        // Handle messages for the protocol
                        _b.sent();
                        // Listen for pubsub messages
                        this._node.pubsub.addEventListener('message', function (evt) {
                            _this._handleMessage(evt.detail);
                        });
                        return [2 /*return*/];
                }
            });
        });
    };
    Peer.prototype.close = function () {
        return __awaiter(this, void 0, void 0, function () {
            var remotePeerIds, hangUpPromises;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        assert(this._node);
                        this._node.peerStore.removeEventListener('change:multiaddrs');
                        this._node.removeEventListener('peer:discovery');
                        this._node.removeEventListener('peer:connect');
                        this._node.removeEventListener('peer:disconnect');
                        this._node.peerStore.removeEventListener('change:multiaddrs');
                        this._node.peerStore.removeEventListener('change:protocols');
                        this._node.pubsub.removeEventListener('message');
                        return [4 /*yield*/, this._node.unhandle(CHAT_PROTOCOL)];
                    case 1:
                        _a.sent();
                        remotePeerIds = this._node.getPeers();
                        remotePeerIds.forEach(function (remotePeerId) { return _this._stopHeartbeatChecks(remotePeerId); });
                        hangUpPromises = remotePeerIds.map(function (peerId) { return __awaiter(_this, void 0, void 0, function () { var _a; return __generator(this, function (_b) {
                            return [2 /*return*/, (_a = this._node) === null || _a === void 0 ? void 0 : _a.hangUp(peerId)];
                        }); }); });
                        return [4 /*yield*/, Promise.all(hangUpPromises)];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Peer.prototype.broadcastMessage = function (message) {
        var e_1, _a;
        try {
            for (var _b = __values(this._peerStreamMap), _c = _b.next(); !_c.done; _c = _b.next()) {
                var _d = __read(_c.value, 2), stream = _d[1];
                stream.push(message);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
    };
    Peer.prototype.floodMessage = function (topic, msg) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        assert(this._node);
                        return [4 /*yield*/, this._node.pubsub.publish(topic, uint8ArrayFromString(JSON.stringify(msg)))];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Peer.prototype.subscribeMessage = function (handler) {
        var _this = this;
        this._messageHandlers.push(handler);
        var unsubscribe = function () {
            _this._messageHandlers = _this._messageHandlers
                .filter(function (registeredHandler) { return registeredHandler !== handler; });
        };
        return unsubscribe;
    };
    Peer.prototype.subscribeTopic = function (topic, handler) {
        var _this = this;
        var _a;
        assert(this._node);
        // Subscribe node to the topic
        this._node.pubsub.subscribe(topic);
        // Register provided handler for the topic
        if (!this._topicHandlers.has(topic)) {
            this._topicHandlers.set(topic, [handler]);
        }
        else {
            (_a = this._topicHandlers.get(topic)) === null || _a === void 0 ? void 0 : _a.push(handler);
        }
        // Create a unsubscribe callback
        var unsubscribe = function () {
            var _a, _b;
            // Remove handler from registered handlers for the topic
            var filteredTopicHandlers = (_a = _this._topicHandlers.get(topic)) === null || _a === void 0 ? void 0 : _a.filter(function (registeredHandler) { return registeredHandler !== handler; });
            if (filteredTopicHandlers === null || filteredTopicHandlers === void 0 ? void 0 : filteredTopicHandlers.length) {
                _this._topicHandlers.set(topic, filteredTopicHandlers);
            }
            else {
                // Remove topic from map and unsubscribe node from the topic if no handlers left
                _this._topicHandlers.delete(topic);
                (_b = _this._node) === null || _b === void 0 ? void 0 : _b.pubsub.unsubscribe(topic);
            }
        };
        return unsubscribe;
    };
    Peer.prototype._handleChangeProtocols = function (_a) {
        var peerId = _a.peerId, protocols = _a.protocols;
        return __awaiter(this, void 0, void 0, function () {
            var _b, connection, stream;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        assert(this._node);
                        // Handle protocol and open stream from only one peer
                        if (this._node.peerId.toString() > peerId.toString()) {
                            return [2 /*return*/];
                        }
                        // Return if stream is self peer or chat protocol is not handled by remote peer
                        if (peerId.equals(this._node.peerId) || !protocols.includes(CHAT_PROTOCOL)) {
                            return [2 /*return*/];
                        }
                        _b = __read(this._node.getConnections(peerId), 1), connection = _b[0];
                        if (!(connection && !connection.streams.some(function (stream) { return stream.stat.protocol === CHAT_PROTOCOL; }))) return [3 /*break*/, 2];
                        return [4 /*yield*/, connection.newStream([CHAT_PROTOCOL])];
                    case 1:
                        stream = _c.sent();
                        this._handleStream(peerId, stream);
                        _c.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    Peer.prototype._dialRelay = function () {
        return __awaiter(this, void 0, void 0, function () {
            var relayMultiaddr, connection, relayPeerId, err_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        assert(this._node);
                        relayMultiaddr = this._relayNodeMultiaddr;
                        _a.label = 1;
                    case 1:
                        if (!true) return [3 /*break*/, 7];
                        _a.label = 2;
                    case 2:
                        _a.trys.push([2, 4, , 6]);
                        console.log("Dialling relay node ".concat(relayMultiaddr.getPeerId(), " using multiaddr ").concat(relayMultiaddr.toString()));
                        return [4 /*yield*/, this._node.dial(relayMultiaddr)];
                    case 3:
                        connection = _a.sent();
                        relayPeerId = connection.remotePeer;
                        // TODO: Check if tag already exists. When checking tags issue with relay node connect event
                        // Tag the relay node with a high value to prioritize it's connection
                        // in connection pruning on crossing peer's maxConnections limit
                        this._node.peerStore.tagPeer(relayPeerId, RELAY_TAG.tag, { value: RELAY_TAG.value });
                        return [3 /*break*/, 7];
                    case 4:
                        err_2 = _a.sent();
                        console.log("Could not dial relay ".concat(relayMultiaddr.toString()), err_2);
                        // TODO: Use wait method from util package.
                        // Issue using util package in react app.
                        return [4 /*yield*/, new Promise(function (resolve) { return setTimeout(resolve, RELAY_REDIAL_DELAY); })];
                    case 5:
                        // TODO: Use wait method from util package.
                        // Issue using util package in react app.
                        _a.sent();
                        return [3 /*break*/, 6];
                    case 6: return [3 /*break*/, 1];
                    case 7: return [2 /*return*/];
                }
            });
        });
    };
    Peer.prototype._handleDiscovery = function (peer) {
        var _a;
        // Check connected peers as they are discovered repeatedly.
        if (!((_a = this._node) === null || _a === void 0 ? void 0 : _a.getPeers().some(function (remotePeerId) { return remotePeerId.toString() === peer.id.toString(); }))) {
            console.log("Discovered peer ".concat(peer.id.toString(), " with multiaddrs"), peer.multiaddrs.map(function (addr) { return addr.toString(); }));
            this._connectPeer(peer);
        }
    };
    Peer.prototype._handleConnect = function (connection) {
        return __awaiter(this, void 0, void 0, function () {
            var remotePeerId, remoteConnections, closeConnectionPromises, protocols, stream, err_3;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        assert(this._node);
                        remotePeerId = connection.remotePeer;
                        // Log connected peer
                        console.log("Connected to ".concat(remotePeerId.toString(), " using multiaddr ").concat(connection.remoteAddr.toString()));
                        if (!(this._node.peerId.toString() < remotePeerId.toString())) return [3 /*break*/, 9];
                        remoteConnections = this._node.getConnections(remotePeerId);
                        if (!(remoteConnections.length > 1)) return [3 /*break*/, 4];
                        if (!connection.remoteAddr.protoNames().includes('p2p-circuit')) return [3 /*break*/, 2];
                        console.log('Closing new connection for already connected peer');
                        return [4 /*yield*/, connection.close()];
                    case 1:
                        _a.sent();
                        console.log('Closed');
                        return [2 /*return*/];
                    case 2:
                        console.log('Closing exisiting connections for new webrtc connection');
                        closeConnectionPromises = remoteConnections.filter(function (remoteConnection) { return remoteConnection.id !== connection.id; })
                            .map(function (remoteConnection) { return remoteConnection.close(); });
                        return [4 /*yield*/, Promise.all(closeConnectionPromises)];
                    case 3:
                        _a.sent();
                        console.log('Closed');
                        _a.label = 4;
                    case 4:
                        _a.trys.push([4, 8, , 9]);
                        return [4 /*yield*/, this._node.peerStore.protoBook.get(remotePeerId)];
                    case 5:
                        protocols = _a.sent();
                        if (!protocols.includes(CHAT_PROTOCOL)) return [3 /*break*/, 7];
                        return [4 /*yield*/, connection.newStream([CHAT_PROTOCOL])];
                    case 6:
                        stream = _a.sent();
                        this._handleStream(remotePeerId, stream);
                        _a.label = 7;
                    case 7: return [3 /*break*/, 9];
                    case 8:
                        err_3 = _a.sent();
                        console.log("Could not create a new protocol stream with ".concat(remotePeerId.toString()), err_3);
                        return [3 /*break*/, 9];
                    case 9:
                        console.log("Current number of peers connected: ".concat(this._node.getPeers().length));
                        // Start heartbeat check peer
                        return [4 /*yield*/, this._startHeartbeatChecks(remotePeerId, function () { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                                return [2 /*return*/, this._handleDeadConnections(remotePeerId)];
                            }); }); })];
                    case 10:
                        // Start heartbeat check peer
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Peer.prototype._handleDeadConnections = function (remotePeerId) {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        // Close existing connections of remote peer
                        console.log("Closing connections for ".concat(remotePeerId));
                        return [4 /*yield*/, ((_a = this._node) === null || _a === void 0 ? void 0 : _a.hangUp(remotePeerId))];
                    case 1:
                        _b.sent();
                        console.log('Closed');
                        return [2 /*return*/];
                }
            });
        });
    };
    Peer.prototype._startHeartbeatChecks = function (peerId, handleDisconnect) {
        return __awaiter(this, void 0, void 0, function () {
            var intervalId;
            var _this = this;
            return __generator(this, function (_a) {
                if (this._peerHeartbeatIntervalIdsMap.has(peerId.toString())) {
                    // Do not start connection check interval if already present
                    return [2 /*return*/];
                }
                intervalId = setInterval(function () { return __awaiter(_this, void 0, void 0, function () {
                    var _this = this;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, this._validatePing(peerId, function () { return __awaiter(_this, void 0, void 0, function () {
                                    return __generator(this, function (_a) {
                                        switch (_a.label) {
                                            case 0:
                                                // Check if connection check interval for peer is already cleared
                                                if (!this._peerHeartbeatIntervalIdsMap.has(peerId.toString())) {
                                                    return [2 /*return*/];
                                                }
                                                // Clear and remove check interval for remote peer if not connected
                                                this._stopHeartbeatChecks(peerId);
                                                return [4 /*yield*/, handleDisconnect()];
                                            case 1:
                                                _a.sent();
                                                return [2 /*return*/];
                                        }
                                    });
                                }); })];
                            case 1:
                                _a.sent();
                                return [2 /*return*/];
                        }
                    });
                }); }, CONN_CHECK_INTERVAL);
                this._peerHeartbeatIntervalIdsMap.set(peerId.toString(), intervalId);
                return [2 /*return*/];
            });
        });
    };
    Peer.prototype._validatePing = function (peerId, handleDisconnect) {
        return __awaiter(this, void 0, void 0, function () {
            var err_4;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        assert(this._node);
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 5]);
                        // Ping remote peer
                        return [4 /*yield*/, this._node.ping(peerId)];
                    case 2:
                        // Ping remote peer
                        _a.sent();
                        return [3 /*break*/, 5];
                    case 3:
                        err_4 = _a.sent();
                        // On error i.e. no pong
                        console.log("Not connected to peer ".concat(peerId.toString()));
                        return [4 /*yield*/, handleDisconnect()];
                    case 4:
                        _a.sent();
                        return [3 /*break*/, 5];
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    Peer.prototype._handleDisconnect = function (connection) {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function () {
            var disconnectedPeerId, peerConnections;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        assert(this._node);
                        disconnectedPeerId = connection.remotePeer;
                        // Log disconnected peer
                        console.log("Disconnected from ".concat(disconnectedPeerId.toString(), " using multiaddr ").concat(connection.remoteAddr.toString()));
                        console.log("Current number of peers connected: ".concat((_a = this._node) === null || _a === void 0 ? void 0 : _a.getPeers().length));
                        peerConnections = this._node.getConnections(disconnectedPeerId);
                        if (!!peerConnections.length) return [3 /*break*/, 2];
                        // Stop connection check for disconnected peer
                        this._stopHeartbeatChecks(disconnectedPeerId);
                        if (!(disconnectedPeerId.toString() === ((_b = this._relayNodeMultiaddr) === null || _b === void 0 ? void 0 : _b.getPeerId()))) return [3 /*break*/, 2];
                        // Reconnect to relay node if disconnected
                        return [4 /*yield*/, this._dialRelay()];
                    case 1:
                        // Reconnect to relay node if disconnected
                        _c.sent();
                        _c.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    Peer.prototype._stopHeartbeatChecks = function (peerId) {
        // Clear check interval for disconnected peer
        var intervalId = this._peerHeartbeatIntervalIdsMap.get(peerId.toString());
        if (intervalId) {
            clearInterval(intervalId);
        }
        this._peerHeartbeatIntervalIdsMap.delete(peerId.toString());
    };
    Peer.prototype._connectPeer = function (peer) {
        return __awaiter(this, void 0, void 0, function () {
            var peerIdString, err_5;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        assert(this._node);
                        peerIdString = peer.id.toString();
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        console.log("Dialling peer ".concat(peerIdString));
                        // When dialling with peer id, all multiaddr(s) (direct/relayed) of the discovered peer are dialled in parallel
                        return [4 /*yield*/, this._node.dial(peer.id)];
                    case 2:
                        // When dialling with peer id, all multiaddr(s) (direct/relayed) of the discovered peer are dialled in parallel
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        err_5 = _a.sent();
                        console.log("Could not dial ".concat(peerIdString), err_5);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    Peer.prototype._handleStream = function (peerId, stream) {
        var _this = this;
        // console.log('Stream after connection', stream);
        var messageStream = pushable({ objectMode: true });
        // Send message to pipe from stdin
        pipe(
        // Read from stream (the source)
        messageStream, 
        // Turn objects into buffers
        function (source) { return map(source, function (value) {
            return uint8ArrayFromString(JSON.stringify(value));
        }); }, 
        // Encode with length prefix (so receiving side knows how much data is coming)
        lp.encode(), 
        // Write to the stream (the sink)
        stream.sink);
        // Handle message from stream
        pipe(
        // Read from the stream (the source)
        stream.source, 
        // Decode length-prefixed data
        lp.decode(), 
        // Turn buffers into objects
        function (source) { return map(source, function (buf) {
            return JSON.parse(uint8ArrayToString(buf.subarray()));
        }); }, 
        // Sink function
        function (source) { var _a, source_1, source_1_1; return __awaiter(_this, void 0, void 0, function () {
            var _loop_1, this_1, e_2_1;
            var _b, e_2, _c, _d;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        _e.trys.push([0, 5, 6, 11]);
                        _loop_1 = function () {
                            _d = source_1_1.value;
                            _a = false;
                            try {
                                var msg = _d;
                                this_1._messageHandlers.forEach(function (messageHandler) { return messageHandler(peerId, msg); });
                            }
                            finally {
                                _a = true;
                            }
                        };
                        this_1 = this;
                        _a = true, source_1 = __asyncValues(source);
                        _e.label = 1;
                    case 1: return [4 /*yield*/, source_1.next()];
                    case 2:
                        if (!(source_1_1 = _e.sent(), _b = source_1_1.done, !_b)) return [3 /*break*/, 4];
                        _loop_1();
                        _e.label = 3;
                    case 3: return [3 /*break*/, 1];
                    case 4: return [3 /*break*/, 11];
                    case 5:
                        e_2_1 = _e.sent();
                        e_2 = { error: e_2_1 };
                        return [3 /*break*/, 11];
                    case 6:
                        _e.trys.push([6, , 9, 10]);
                        if (!(!_a && !_b && (_c = source_1.return))) return [3 /*break*/, 8];
                        return [4 /*yield*/, _c.call(source_1)];
                    case 7:
                        _e.sent();
                        _e.label = 8;
                    case 8: return [3 /*break*/, 10];
                    case 9:
                        if (e_2) throw e_2.error;
                        return [7 /*endfinally*/];
                    case 10: return [7 /*endfinally*/];
                    case 11: return [2 /*return*/];
                }
            });
        }); });
        // TODO: Check if stream already exists for peer id
        this._peerStreamMap.set(peerId.toString(), messageStream);
    };
    Peer.prototype._handleMessage = function (msg) {
        var _a;
        // Messages should be signed since globalSignaturePolicy is set to 'StrictSign'
        assert(msg.type === 'signed');
        // Send msg data to registered topic handlers
        (_a = this._topicHandlers.get(msg.topic)) === null || _a === void 0 ? void 0 : _a.forEach(function (handler) {
            var dataObj = JSON.parse(uint8ArrayToString(msg.data));
            handler(msg.from, dataObj);
        });
    };
    return Peer;
}());
export { Peer };
//# sourceMappingURL=index.js.map